<template>
  <q-badge
    v-if="unread > 0"
    color="red"
    floating
    :label="unread"
  />
</template>

<script>
import queryMessagesStatus from '../graphql/queryMessagesStatus.gql'

export default {
  name: 'MessagingUnreadBadge',
  data () {
    return {
      messagesStatus: []
    }
  },
  apollo: {
    messagesStatus: {
      query: queryMessagesStatus,
      notifyOnNetworkStatusChange: true,
      update: data => data.message,
      pollInterval: 60000
    }
  },
  computed: {
    unread () {
      let unreadCount = 0
      for (const messageStatus of this.messagesStatus) {
        const message = messageStatus.broadcast ?? messageStatus.ticket
        const readAt = message?.statuses?.[0]?.readAt || message.readAt
        if (!readAt || readAt < messageStatus.lastUpdatedAt) {
          unreadCount++
        }
      }
      return unreadCount
    },
    lastPushNotificationOpenedAt () {
      return this.$store.state.appState.lastPushNotificationOpenedAt
    }
  },
  watch: {
    lastPushNotificationOpenedAt: function () {
      // refetch query when a notification has been opened as it means they are new messages
      this.$apollo.queries.messagesStatus.refetch()
    }
  }
}
</script>
